<template>
  <div class="w-full h-full flex flex-col gap-4 md:!px-0 px-5">
    <div class="w-full flex flex-col gap-4 xl:!px-0">
      <div class="flex flex-col gap-4 md:flex-row md:items-center">
        <!-- Searchbar -->
        <svn-pro-text-field
          v-model="currentSearch"
          variant="outlined"
          placeholder="Search"
          prepend-inner-icon="custom:mingcute:search-2-line"
          @update:model-value="search"
        />

        <div class="flex gap-4 items-center">
          <!-- Toggle Filter button -->
          <svn-pro-button
            v-if="showFilter"
            text="Filter"
            :append="activeFilterCount ? true : false"
            :prepend-icon="'custom:mingcute:filter-2-line'"
            :variant="activeFilterCount ? 'tonal' : 'text'"
            @click="toggleFilterVisibility"
          >
            <template v-if="activeFilterCount" #append>
              {{ `(${activeFilterCount})` }}
            </template>
          </svn-pro-button>

          <div v-if="allowViewChange">
            <svn-pro-button-toggle
              v-model="activeView"
              :items="viewToggleButtons"
              variant="outlined"
              @update:modelValue="changeView"
            />
          </div>
        </div>
      </div>
    </div>

    <slot v-if="showFilter" name="filter-items" />

    <div
      v-if="activeView === ViewTypes.LIST"
      class="flex flex-col md:flex-row items-start md:items-center justify-normal md:justify-between"
    >
      <svn-pro-title
        v-if="selectedOnResultCount"
        class="h-[40px]"
        :h5="!isMobile"
        :h6="isMobile"
        medium
      >
        {{ `${selectedOnResultCount}/${totalCount}` }}
      </svn-pro-title>

      <svn-pro-title
        v-else
        :h5="!isMobile"
        :h6="isMobile"
        medium
        class="h-[40px]"
      >
        {{ totalCount }}
      </svn-pro-title>

      <slot name="actions"></slot>
    </div>

    <v-data-table
      v-if="activeView === ViewTypes.LIST"
      :items="items"
      :headers="headers"
      :density="density"
      :items-per-page="itemsPerPage"
      :loading="loading"
      :show-select="showSelect"
    >
      <template #header.data-table-select>
        <div class="w-[40px]">
          <v-checkbox
            :model-value="variant == DataTableVariant.EVERYONE"
            hide-details
            :indeterminate="
              !!(
                variant === DataTableVariant.MANUAL_DESELECTION ||
                (variant === DataTableVariant.MANUAL_SELECTION &&
                  modelValue?.length)
              )
            "
            @update:model-value="handleSelection"
          />
        </div>
      </template>

      <template #item="{ item, index }">
        <slot
          name="item"
          :item="item"
          :handleRowSelection="handleRowSelection"
          :index="index"
          :isChecked="isChecked"
        />
      </template>

      <template #loading>
        <slot name="loading" />
      </template>

      <template #no-data>
        <slot name="no-data" />
      </template>

      <template #bottom>
        <svn-pro-pagination
          v-if="paginationTotalPages > 1"
          :page="currentPage"
          :length="paginationTotalPages"
          class="mt-6"
          @update:model-value="updatePagination"
        />
      </template>
    </v-data-table>

    <template v-else>
      <div
        v-if="!loading && items.length"
        class="flex flex-wrap md:!grid md:grid-cols-2 lg:!grid-cols-3 xl:!grid-cols-4 w-full gap-4 justify-center md:!justify-start items-center"
      >
        <template v-for="(item, index) in items" :key="index">
          <slot :item="item" :index="index" name="grid-item" />
        </template>
      </div>

      <slot
        v-else-if="!loading && (!items || items.length === 0)"
        name="no-data"
      />

      <slot v-else name="loading">
        <div class="h-[400px] w-full flex items-center justify-center">
          <svn-pro-progress-circular :width="5" indeterminate />
        </div>
      </slot>

      <slot name="bottom">
        <svn-pro-pagination
          v-if="!loading && items.length && paginationTotalPages > 1"
          :page="currentPage"
          :length="paginationTotalPages"
          class="mt-6"
          @update:model-value="updatePagination"
        />
      </slot>
    </template>
  </div>
</template>

<script setup>
import { ref, watch, onMounted, onUnmounted } from 'vue';
import SvnProPagination from '../pagination/SvnProPagination.vue';
import SvnProTextField from '@/components/input/SvnProTextField.vue';
import SvnProButton from '@/components/button/SvnProButton.vue';
import SvnProTitle from '@/components/styles/SvnProTitle.vue';
import { DataTableVariant } from '@/constants/types';
import SvnProButtonToggle from '@/components/button/SvnProButtonToggle.vue';
import { ViewTypes } from '../../constants/types';
import SvnProProgressCircular from '../progress/SvnProProgressCircular.vue';

const props = defineProps({
  modelValue: {
    type: undefined,
    default: null,
  },
  items: {
    type: Array,
    default: () => [],
  },
  headers: {
    type: Array,
    default: () => [],
  },
  density: {
    type: String,
    default: 'default',
  },
  loading: {
    type: Boolean,
    default: false,
  },
  showSelect: {
    type: Boolean,
    default: false,
  },
  allowViewChange: {
    type: Boolean,
    default: false,
  },
  defaultActiveView: {
    type: String,
    default: ViewTypes.LIST,
    validator: (value) => Object.values(ViewTypes).includes(value),
  },
  page: {
    type: Number,
    default: 1,
  },
  itemsPerPage: {
    type: Number,
    default: 1,
  },
  paginationTotalPages: {
    type: Number,
    default: 1,
  },
  showFilter: {
    type: Boolean,
    default: false,
  },
  activeFilterCount: {
    type: Number,
    default: 0,
  },
  selectedOnResultCount: {
    type: Number,
    default: 0,
  },
  totalCount: {
    type: Number,
    default: 0,
  },
  variant: {
    type: String,
    default: DataTableVariant.MANUAL_SELECTION,
    validator: (value) => Object.values(DataTableVariant).includes(value),
  },
});

const emit = defineEmits([
  'update:modelValue',
  'update-pagination',
  'refetch',
  'selected-items',
  'toggle-filter-visibility',
  'change-view',
]);

onMounted(() => {
  activeView.value = props.defaultActiveView || ViewTypes.LIST;
  model.value = props?.modelValue;
  isMobile.value = window.innerWidth < 640;
  window.addEventListener('resize', handleWindowResize);
});

const model = ref([]);
const currentPage = ref(props?.page);
const currentSearch = ref('');
const deselectedIds = ref([]);
const isMobile = ref(false);
const activeView = ref(ViewTypes.LIST);

const viewToggleButtons = ref([
  {
    value: ViewTypes.GRID,
    icon: 'custom:mingcute:grid-line',
    disabled: false,
  },
  {
    value: ViewTypes.LIST,
    icon: 'custom:mingcute:list-check-line',
    disabled: false,
  },
]);

// Handle model updates based on selection behavior
const handleSelection = () => {
  deselectedIds.value = [];
  if (props.variant === DataTableVariant.MANUAL_SELECTION) {
    emit('selected-items', DataTableVariant.EVERYONE, []);
  } else {
    emit('selected-items', DataTableVariant.MANUAL_SELECTION, []);
  }
};

const updatePagination = (page) => {
  emit('refetch', page, currentSearch.value);
};

watch(props, (newValue) => {
  if (newValue.modelValue) {
    model.value = newValue.modelValue;
  }
  if (newValue.page) {
    currentPage.value = newValue.page;
  }

  if (newValue.defaultActiveView) {
    activeView.value = newValue.defaultActiveView;
  }
});

const search = () => {
  emit('refetch', 1, currentSearch.value);
};

const toggleFilterVisibility = () => {
  emit('toggle-filter-visibility');
};

onUnmounted(() => {
  window.removeEventListener('resize', handleWindowResize);
});

const handleWindowResize = (e) => {
  isMobile.value = e.target.innerWidth < 640;
};

const handleRowSelection = (id) => {
  // Check if the table variant is either 'everyone' or 'manualDeselection'
  if (
    props.variant === DataTableVariant.EVERYONE ||
    props.variant === DataTableVariant.MANUAL_DESELECTION
  ) {
    // Case 1: Deselect the row if it's currently deselected
    if (deselectedIds.value.includes(id)) {
      // Remove the ID from the list of deselected rows
      deselectedIds.value = deselectedIds.value.filter(
        (itemId) => itemId !== id
      );
    } else {
      // Case 2: Select the row by adding its ID to the deselected list
      deselectedIds.value.push(id);
    }

    // Emit an event to notify the parent component of the updated state
    // If there are deselected IDs, the variant is 'manualDeselection'; otherwise, it's 'everyone'
    emit(
      'selected-items',
      deselectedIds.value?.length
        ? DataTableVariant.MANUAL_DESELECTION
        : DataTableVariant.EVERYONE,
      deselectedIds.value
    );
  } else {
    // Handle other table variants (defaulting to 'manualSelection')
    // Case 3: Deselect the row if it's currently selected
    if (model.value.includes(id)) {
      // Create a new array without the deselected row's ID
      const newUserIds = model.value.filter((itemId) => itemId !== id);
      // Emit an event indicating a manual selection update with the new list of selected IDs
      emit('selected-items', DataTableVariant.MANUAL_SELECTION, newUserIds);
    } else {
      // Case 4: Select the row by adding its ID to the model
      model.value.push(id);
      emit('selected-items', DataTableVariant.MANUAL_SELECTION, model.value);
    }
  }
};

const isChecked = (id) => {
  return (
    // Case 1: 'everyone' variant, all rows are selected by default
    props.variant == DataTableVariant.EVERYONE ||
    // Case 2: 'manualSelection' variant, check if the row is in the selected model
    (props.variant == DataTableVariant.MANUAL_SELECTION &&
      model.value.includes(id)) ||
    // Case 3: 'manualDeselection' variant, check if the row is not in the selected model
    (props.variant == DataTableVariant.MANUAL_DESELECTION &&
      !model.value.includes(id))
  );
};

const changeView = (value) => {
  emit('change-view', value);
};
</script>
